#if !defined(__BITMAP_HPP)
#define __BITMAP_HPP

#include <SophiaFramework.hpp>

SFMTYPEDEFCLASS(Bitmap)
class Bitmap {
private:
    SFBBitmapSmp _pbitmap;      // rbg}bvւ̃|C^
    SFBDIBSmp _pdib;            // DIB `̃rbg}bvւ̃|C^

    SFCError GetDib(Void);      // DIB `̃rbg}bv擾
    SFCError Copy(BitmapConstRef bitmap);   // rbg}bvRs[

public:
    Bitmap(Void);
    Bitmap(ACharConstPtr file);
    Bitmap(WCharConstPtr file);
    Bitmap(SFXAnsiStringConstRef file);
    Bitmap(SFXWideStringConstRef file);
    Bitmap(ACharConstPtr resFile, UInt16 id);
    Bitmap(WCharConstPtr resFile, UInt16 id);
    Bitmap(SFXAnsiStringConstRef resFile, UInt16 id);
    Bitmap(SFXWideStringConstRef resFile, UInt16 id);
    Bitmap(SFBBitmapSmpConstRef pbitmap);
    Bitmap(BitmapConstRef bitmap);
    ~Bitmap(Void);
    SFCError LoadBitmap(ACharConstPtr file);
    SFCError LoadBitmap(WCharConstPtr file);
    SFCError LoadBitmap(SFXAnsiStringConstRef file);
    SFCError LoadBitmap(SFXWideStringConstRef file);
    SFCError LoadResBitmap(ACharConstPtr resFile, UInt16 id);
    SFCError LoadResBitmap(WCharConstPtr resFile, UInt16 id);
    SFCError LoadResBitmap(SFXAnsiStringConstRef resFile, UInt16 id);
    SFCError LoadResBitmap(SFXWideStringConstRef resFile, UInt16 id);
    SFCError Create(SFBBitmapSmpConstRef pbitmap);
    BitmapConstRef operator =(SFBBitmapSmpConstRef pbitmap);
    BitmapConstRef operator =(BitmapConstRef bitmap);
    SFXRGBColor GetPixel(SFXPixelConstRef pixel) const;
    SFXRGBColor GetPixel(SInt16 x, SInt16 y) const {
        return GetPixel(SFXPixel(x, y));
    }
    SFXSize GetSize(Void) const;
    UInt16 GetWidth(Void) const;
    UInt16 GetHeight(Void) const;
    UInt08 GetDepth(Void) const;
};

#endif
