#ifndef __COMPLEX_H
#define __COMPLEX_H

#include <SophiaFramework.hpp>


// fNX


SFMTYPEDEFCLASS(Complex)
class Complex {
private:
    Float64 _x;
    Float64 _y;

public:
    // RXgN^
    Complex(Float64 x = 0, Float64 y = 0);
    Complex(ComplexConstRef z);
    // fBXgN^
    ~Complex(Void);

    // E̎擾/ݒ
    Float64 GetReal(Void) const;
    Float64 GetImaginary(Void) const;
    static Float64 GetReal(ComplexConstRef z);
    static Float64 GetImaginary(ComplexConstRef z);
    ComplexConstRef SetReal(Float64 x);
    ComplexConstRef SetImaginary(Float64 y);

    // 萔w炵g
    Float64ConstRef Re(Void) const;
    Float64Ref Re(Void);
    static Float64 Re(ComplexConstRef z);
    Float64ConstRef Im(Void) const;
    Float64Ref Im(Void);
    static Float64 Im(ComplexConstRef z);

    Float64 Abs(Void) const;
    Float64 Abs2(Void) const;
    static Float64 Abs(ComplexConstRef z);
    static Float64 Abs2(ComplexConstRef z);
    Complex GetCC(Void) const;      // f擾
    static Complex GetCC(ComplexConstRef z);    // f擾

    ComplexConstRef operator=(ComplexConstRef z);
    ComplexConstRef operator=(Float64 a);
    Complex operator+(ComplexConstRef z) const;
    Complex operator+(Float64 a) const;
    friend Complex operator+(Float64 a, ComplexConstRef z);
    ComplexConstRef operator+(Void) const;
    Complex operator-(ComplexConstRef z) const;
    Complex operator-(Float64 a) const;
    friend Complex operator-(Float64 a, ComplexConstRef z);
    Complex operator-(Void) const;
    Complex operator*(ComplexConstRef z) const;
    Complex operator*(Float64 a) const;
    friend Complex operator*(Float64 a, ComplexConstRef z);
    Complex operator/(ComplexConstRef z) const;
    Complex operator/(Float64 a) const;
    friend Complex operator/(Float64 a, ComplexConstRef z);
    ComplexConstRef operator+=(ComplexConstRef z);
    ComplexConstRef operator+=(Float64 a);
    ComplexConstRef operator-=(ComplexConstRef z);
    ComplexConstRef operator-=(Float64 a);
    ComplexConstRef operator*=(ComplexConstRef z);
    ComplexConstRef operator*=(Float64 a);
    ComplexConstRef operator/=(ComplexConstRef z);
    ComplexConstRef operator/=(Float64 a);
};


#endif
