#ifndef __RECOGENGINE_H
#define __RECOGENGINE_H

#include <SophiaFramework.hpp>
#include "Matrix.hpp"
#include "Complex.hpp"
#include "Bitmap.hpp"

#define COORD_NUMBER    128         // ̗p֊s_̐
#define PARCOR_ORDER    32          // PARCOR W̎
#define PARCOR_TABLE_NAME   "table.dat"     // e[ut@C̖O

#ifdef MAKE_PARCOR_TABLE
#include "chars.brh"                // ƂȂ摜o^\[X
#define TABLE_SIZE      26          // Ή镶̎
#endif

#ifdef EMULATOR_TEST
#include "chars.brh"
#endif

SFMTYPEDEFCLASS(RecogEngine)
class RecogEngine {
private:

virtual Bool Copy(RecogEngineConstRef obj);
    Void MakeGrayScale(Void);       // O[EXP[摜𐶐
    UInt08 CalcThreshold(Void);     // 2l̂߂臒lZo
    Void MakeMonochrome(Void);      // 2l
    Void GetOutline(Void);          // ֊s𒊏o
    Void GetCoordinatePoints(Void); // ֊s_𒊏o
    Void CalcParcor(Void);          // f PARCOR WvZ

protected:
    SFXWideString _recogString;     // F̕
    Matrix<UInt08> _monochrome;     // 摜ۑp
    Array<Complex> _coord;          // ֊s_ۑp
    Array<Complex> _parcor;         // ̉摜Ɋւ PARCOR W
    Matrix<Complex> _parcorTable;   // PARCOR W̃e[u
    Array<WChar> _charTable;        // _parcorTable ɑΉ镶i[
    BitmapPtr _pbitmap;             // ƂȂ摜
    SInt16 _bitmapWidth;            // 摜̕
    SInt16 _bitmapHeight;           // 摜̍
    Bool _processFlag;              // Ȍɐǂ
    SInt16 _coordNumber;            // ̗p֊s_̐
    SInt16 _parcorOrder;            // PARCOR W̎
#if !defined(MAKE_PARCOR_TABLE)
    Bool _parcorTableLoaded;        // PARCOR W̃e[uǍ߂
#endif

public:
    RecogEngine(Void);                      // RXgN^
    RecogEngine(RecogEngineConstRef obj);   // Rs[RXgN^
    virtual ~RecogEngine(Void);             // fBXgN^
#if defined(MAKE_PARCOR_TABLE)
    Bool MakeParcorTable(Void);             // PARCOR W̃e[u쐬
    Bool SaveParcorTable(Void);             // PARCOR W̃e[uۑ
#endif
    Bool LoadParcorTable(Void);             // PARCOR W̃e[uǍ
    Bool Recognize(SFBBitmapSmpConstRef pbitmap);       // ^ꂽ摜𕶎ƂĔF
    SFXWideStringConstRef GetString(Void) const;    // F擾
};

#endif
